#include "asm86.h"
#include "old86.h"
#include "ti86asm.inc"

_load_ram_ahl       equ     $462F	;Converts ahl to ASIC, loads RAM page.

_dispahl            equ     $4A33	;Displays ahl in decimal.

_runoff				equ     $4AB1	;Disable run indicator.

_runon              equ     $4AAD	;Enable run indicator.

_off                equ     $4101	;Turn off calc.

_getcode            equ     $4068	;Get scancode, but 1000's of clocks faster than GET_KEY.

_exec_asm           equ     $5730	;Execute z80 assembly program in OP1.

_op5toop1           equ     $4247
_op1toop5           equ     $426B
anumeditflgs        equ     $1F
ex_asm_module       equ     $02

#define RelocArea           $E000
#define TotalDTs            $E500
#define Pointer2dtVAT       $E500+2
#define dtVAT               $E500+4
#define	TotalVars           $E800
#define	PointerPos          $E800+2
#define	Pointer2VAT         $E800+4
#define	Pointer2AVAT        $E800+6
#define	AVAT                $E800+8

.org _asm_exec_ram


DTdetecter:
    ei
    res  ex_asm_module,(iy+anumeditflgs)
    ld   hl,0
    ld   (TotalDTs),hl
    ld   hl,dtVAT
    ld   (Pointer2dtVAT),hl
    ld   hl,$BFFF
    ld   a,$47
    out  (6),a
dtSearchLoop:
    ld   de,(VAT_END)
    inc  de
    or   a
    sbc  hl,de
    jp   c,EndOfDTs
    add  hl,de
    ld   (Pointer2VAT),hl	;this is the start of the vat entry
    ld   a,(hl)
    cp   $0C					;needs to be a string
    jp   nz,dtSkipVarName	;no? go to here

dtMoveName2OP1:
    ld   de,-5
    add  hl,de
    ld   b,(hl)				;save length byte for djnz
    inc  b
    ld   ix,_OP1				;this is where we are gonna put the var name
dtName2OP1:
    inc  ix
    ld   a,(hl)
    ld   (ix),a
    dec  hl					;simple routine to move b bytes from hl to ix (backward)
    djnz dtName2OP1

dtCheckLoop:
    rst  10h
    ld   a,b
    ex   de,hl	
    call _load_ram_ahl
    inc  hl
    inc  hl
    ld   a,(hl)				;get the first byte
    cp   0					;make sure that it was a nop
    jr   nz,dtSkipVarName	;if not, start on the next var
    inc  hl					;have to check the next byte as well
    ld   a,(hl)				;so get it
    cp   $4D				;make sure its 'M'
    jr   nz,dtSkipVarName	;if not, start the next var
    call SetPorts4Move
    ld	 de,9				;yay, it was :)
    add  hl,de
    ld   b,(hl)				;this is how many DTs there are in the file
    ld   a,(TotalDTs)		
    add  a,b				;add em to our DT var
    ld   (TotalDTs),a
    push hl					;copy hl to ix
    pop  ix
    inc	 ix					;point to the first data type
MovedtTables:
    push bc					;save b (the counter)
    ld   a,(ix+2)			;ix+2 is the length of the table
    add  a,a				;the size byte is only half the actuall size (becuase the mask needs to be included
    add  a,3				;and there are 3 bytes before the size
    ld	 b,a				;so b= 3 + (length*2)
    ld   de,(Pointer2dtVAT)
MoveTable:
    ld   a,(ix)
    ld   (de),a
    inc  ix
    inc  de
    djnz MoveTable
    ld   hl,_OP1+1
    ld   b,9
MoveVATentry:
    ld   a,(hl)
    ld   (de),a
    inc  hl
    inc  de
    djnz MoveVATentry
    ld   (Pointer2dtVAT),de
    pop  bc
    djnz MovedtTables

dtSkipVarName:
    ld   a,$0d
    out  (5),a
    ld   a,$47
    out  (6),a
    ld   hl,(Pointer2VAT)
    ld   de,-5
    add  hl,de
    ld   b,(hl)
    inc  b
dtSkipName:
    dec  hl
    djnz dtSkipName
    jp   dtSearchLoop

EndOfDTs:
    ld   a,(TotalDTs)
    cp   0
    ret  z

ScreenSetup:
    call _clrScrn
    call _runoff
    call DoLines
    call DoTopBar
    ld   de,$0701
    ld   hl,Folder1
    call DispIt
    ld   de,$0D01
    ld   hl,Folder2
    call DispIt
    ld   de,$1301
    ld   hl,Folder3
    call DispIt
    ld   de,$1901
    ld   hl,Folder4
    call DispIt
    ld   de,$1F01
    ld   hl,Folder5
    call DispIt
    ld   de,$2501
    ld   hl,Folder6
    call DispIt
    ld   de,$2B01
    ld   hl,Folder7
    call DispIt
    ld   de,$3101
    ld   hl,Recycle
    call DispIt
    call InvertSelector
    ld   a,(PosStatus)
    cp   1
    jp   z,InitVarStuff
    call GetFreeMem

InitGetLoop:
    call _getcode
    cp   K_UP
    jp   z,MoveUp
    cp   K_DOWN
    jp   z,MoveDown
    cp   K_ALPHA
    jp   z,InitVarStuff
    cp   K_EXIT
    jp   z,Exit
    cp   K_PLUS
    call z,ContrastUp
    cp   K_MINUS
    call z,ContrastDn
    cp   K_CLEAR
    call z,ShutCalcOff
    jr   InitGetLoop

MoveUp:
    ld   a,(Posl)
    push af
    call InvertSelector
    pop  af
    cp   1
    call z,HopBarDown
    dec  a
    ld   (Posl),a
    call InvertSelector
    ld   a,(Posl)
    call ClearProgPlace
    jp   InitGetLoop
HopBarDown:
    ld   a,9
    ret

MoveDown:
    ld   a,(Posl)
    push af
    call InvertSelector
    pop  af
    cp   8
    call z,HopBarUp
    inc	 a
    ld   (Posl),a
    call InvertSelector
    call ClearProgPlace
    jp   InitGetLoop
HopBarUp:
    ld   a,0
    ret

;##############################
;# Variable Selector Routines #
;##############################

InitVarStuff:
    ld   a,(Posl)
    dec  a
    ld   (CurFolder),a
    call FindVars
    ld   a,(TotalVars)
    cp   0
    jp   z,DispNoProgs
    ld   a,(CurVar)
    ld   b,a
    ld   a,(TotalVars)
    cp   b
    jr   c,ResetPosr
    push bc
    ld   a,(VarPage)
    ld   h,a
    ld   l,16
    call MUL_HL
    ld   a,l
    sub  15
    ld   (CurVar),a
    ld   a,(Posr)
    push af
    call DispProgs
    pop  af
    ld   (Posr),a
    ld   b,a
    pop  af
    ld   (CurVar),a
    jr   FinishInit

ResetPosr:
    ld   a,1
    ld   (CurVar),a
    ld   (VarPage),a
    call DispProgs
    ld   a,1
    ld   (CurVar),a
    ld   (Posr),a

FinishInit:
    set  3,(iy+5)
    call DisplayHandler
    call Get_Size
    res  3,(iy+5)
    ld   a,1
    ld   (PosStatus),a
VarsGetLoop:
    halt
    call _getcode
    cp   K_NOKEY
    jr   z,VarsGetLoop
    cp   K_UP
    jp   z,ProgUp
    cp   K_DOWN
    jp   z,ProgDown
    cp   K_SECOND
    jp   z,ExecProg
	cp   K_ENTER
	jp   z,ExecProg
    cp   K_DEL
    jp   z,Move2Recycle
    cp	 K_XVAR
    jp   z,MoveProg
    cp   K_PLUS
    call z,ContrastUp
    cp   K_MINUS
    call z,ContrastDn
    cp   K_LEFT
    jp   z,ProgLeft
    cp   K_RIGHT
    jp   z,ProgRight
    cp   K_ALPHA
    jp   z,Back2Folders
    cp   K_EXIT
    jp   z,Exit
    cp   K_CLEAR
    call z,ShutCalcOff
    jr   VarsGetLoop

ProgLeft:
    ld   a,(Posr)
    sub  9
    jp   c,VarsGetLoop
    call DisplayHandler
    ld   a,(Posr)
    sub  8
    ld   (Posr),a
    ld   a,(CurVar)
    sub  8
    ld   (CurVar),a
    jp   DisplayProg

ProgRight:
    ld   a,(Posr)

    sub  9
    jp   nc,VarsGetLoop
    ld   a,(CurVar)
    add  a,8
    ld   b,a
    ld   a,(TotalVars)
    sub  b
    jp   c,VarsGetLoop
    call DisplayHandler

    ld   a,(Posr)
    add  a,8
    ld   (Posr),a
    ld   a,(CurVar)
    add  a,8
    ld   (CurVar),a
    jp   DisplayProg

ProgUp:
    ld   a,(CurVar)
    cp   1
    jp   z,VarsGetLoop
    call DisplayHandler

    ld   a,(CurVar)
    dec  a
    ld   (CurVar),a
    ld   a,(Posr)

    cp   1

    jr   nz,SkipPageUp
    ld   a,(VarPage)
    dec  a
    ld   (VarPage),a
    ld   a,(CurVar)
    sub  15
    ld   (CurVar),a
    call DispProgs
    ld   a,17
SkipPageUp:
    dec  a
    ld   (Posr),a

    jp   DisplayProg



ProgDown:
    ld   a,(CurVar)
    ld   hl,TotalVars
    cp   (hl)
    jp   z,VarsGetLoop
    call DisplayHandler
    ld   a,(CurVar)
    inc  a
    ld   (CurVar),a
    ld   a,(Posr)
    cp   16
    jr   nz,SkipPageDown
    ld   a,(VarPage)
    inc  a
    ld   (VarPage),a
    ld   a,(CurVar)
    push af
    call DispProgs
    pop  af
    ld   (CurVar),a
    ld   a,0
SkipPageDown:
    inc  a
    ld   (Posr),a
DisplayProg:
    set  3,(iy+5)
    call DisplayHandler

    res  1,(iy+5)
    call Get_Size
    jp   VarsGetLoop


Back2Folders:
    xor  a
    ld   (PosStatus),a
    jp   ScreenSetup

DispNoProgs:
    ld   hl,$1B33
    ld   (_penCol),hl
    ld   hl,NoProgs_Str
    call _vputs
    jp   InitGetLoop

ExecProg:
    call SaveVars
    call GetdtVar
    push hl					;save it while we are pointing to the start of the program
    ld   de,6
    add  hl,de
    ld   e,(hl)
    inc  hl					;exec code is de bytes down the road
    ld   d,(hl)
    inc  hl
    ld   c,(hl)
    inc  hl					;and bc is how many bytes the routine is
    ld   b,(hl)
    pop  hl					;get hl back pointing to the comment dw
    add  hl,de					;point hl to the comment routine
    ld   de,RelocArea			;this is where it will run from
    ldir					;copy the routine to RelocArea
    call SetPortsNorm
    call UpdateCurProg
    rst	 20h
    ld	 a,(_OP1)
    jp	 RelocArea				;call the routine. 

MoveProg:
    ld   a,1
    ld   (PointerPos),a
    call PlaceArrow

MoveGetLoop:
    halt
    call _getcode
    cp   K_NOKEY
    jr   z,MoveGetLoop
    cp   K_UP
    jr   z,MovePointerUp
    cp   K_DOWN
    jr   z,MovePointerDn
    cp   K_SECOND
    jp   z,Move2Folder
    cp   K_ENTER
    jp   z,Move2Folder
    cp   K_CLEAR
    call z,ShutCalcOff
    cp   K_EXIT
    jr   nz,MoveGetLoop
    ld   a,(PointerPos)
    call EraseArrow
    jp   VarsGetLoop

MovePointerUp:
    call EraseArrow
    ld   a,(PointerPos)
    cp   1
    call z,HopPointerDown
    dec  a
    ld   (PointerPos),a
    call PlaceArrow
    jr   MoveGetLoop
HopPointerDown:
    ld   a,9
    ret

MovePointerDn:
    call EraseArrow
    ld   a,(PointerPos)
    cp   8
    call z,HopPointerUp
    inc  a
    ld   (PointerPos),a
    call PlaceArrow
    jr   MoveGetLoop
HopPointerUp:
    ld   a,0
    ret

EraseArrow:
    call GetPointerOffset
    ld   hl,Spaces_Str
    call _vputs
    ret

PlaceArrow:
    call GetPointerOffset
    ld   a,$CF
    call _vputmap
    ret 

GetPointerOffset:
    ld   a,(PointerPos)
    ld   h,a
    ld   l,6
    call MUL_HL
    inc  hl
    ld   (_penRow),hl
    ld   a,34
    ld   (_penCol),a
    ret

Move2Recycle:
    ld   a,(CurFolder)
    cp   7
    jp   z,DeleteProg
    ld   a,8				;gonna dec it in a second (8 folders starting at 0)
    jr   MoveIt

Move2Folder:
    ld   a,(PointerPos)
    push af
    call EraseArrow
    pop  af

MoveIt:
    dec  a
    push af
    call UpdateCurProg
    rst  20h
    rst  10h
    ld   de,-4
    add  hl,de
    pop  af
    ld   (hl),a
    jr   FixFromMove
	
DeleteProg:
    call UpdateCurProg
    rst  20h
    rst  10h
    call nc,_delvar

FixFromMove:
    call ClearProgPlace
    call ClearDescriptPlace
    ld   a,(Posr)
    cp   1
    jr   z,TisAtTop
    ld   c,a
    ld   a,(CurVar)
    ld   b,a
    ld   a,(TotalVars)
    dec  a					;just deleted a var, so we must dec it
    cp   b
    jp   nc,InitVarStuff
    ld   a,c
    dec  a
    ld   (Posr),a
    ld   a,(CurVar)
    dec  a
    ld   (CurVar),a
    jp   InitVarStuff

TisAtTop:
    ld   a,(VarPage)
    cp   1
    jp   z,InitVarStuff
    ld   a,16
    ld   (Posr),a
    ld   a,(CurVar)
    dec  a
    ld   (CurVar),a
    ld   a,(VarPage)
    dec  a
    ld   (VarPage),a    
    jp   InitVarStuff

Get_Size:
    call GetdtVar
    push hl
    inc  hl
    inc  hl
    ld   e,(hl)
    inc  hl						;comment code is de bytes down the road
    ld   d,(hl)
    inc  hl
    ld   c,(hl)
    inc  hl						;and bc is how many bytes the routine is
    ld   b,(hl)
    pop  hl						;get hl back pointing to the comment dw
    add  hl,de					;point hl to the comment routine
    ld   de,RelocArea			;this is where it will run from
    ldir						;copy the routine to RelocArea
    call SetPortsNorm
    call UpdateCurProg
    rst  20h
    ld   a,(_OP1)				;we want to save the 1 letter description for the comment routines
    ld   (_OP2),a
    rst  10h						;now we're gonna setup the correct pages and such for the program
    ld   a,b
    ex   de,hl
    call _load_ram_ahl	
    call SetPorts4Move
    ld   a,(hl)					;get the size while its handy
    ld   (_OP2+2),a
    inc	 hl
    ld   a,(hl)
    ld   (_OP2+1),a				;put it into OP2+1
    inc  hl						;hl points to the first byte of the program
    ld   a,(_OP2)				;a has the 1 byte description
    call RelocArea				;call the routine. nc means that a descript was found
    jr   nc,DisplayInfo			

RegularMove:						;if there was a carry, just copy the name as the description
    ld   hl,_OP1+2
    ld   de,_OP2+3
    ld   a,(_OP1+1)
    ld   c,a
    ld   b,0
    ldir 
    xor  a
    ld   (de),a

DisplayInfo:
    call SetPortsNorm
    set  3,(iy+5)				;size will be white on black
    ld   de,$005C

    ld   (_penCol),de
    ld   hl,SizeStr
    call _vputs

    ld   a,(_OP2+2)
    ld   l,a
    ld   a,(_OP2+1)
    ld   h,a
    xor  a

    ld   de,-1

    ld   (_curRow),de

    call _dispahl

    dec  hl

    call _vputs
    ld   b,13
BustOutSomeSpaces:
    ld   a,' ' 
    call _vputmap
    djnz BustOutSomeSpaces
    res  3,(iy+5)
    call ClearDescriptPlace
    ld   de,$3901

    ld   (_penCol),de
    ld   hl,_OP2+3
    call _vputs
    ld   de,$3969

    ld   (_penCol),de
    ld   hl,TypeStr
    call _vputs
    ld   a,(_OP2)
    call _vputmap
    ret

DisplayHandler:
    call UpdateCurProg
    rst  20h
    set  1,(iy+5)
    ld   a,(Posr)

    cp   9
    ld   b,38
    jr   c,FirstCol
SecondCol:
    sub  8
    ld   b,82
FirstCol:
    push bc
    ld   h,a

    ld   l,6

    call MUL_HL

    inc  hl
    ld   (_penRow),hl

    pop  bc
    ld   a,b

    ld   (_penCol),a

    ld   hl,Spaces_Str
    call _vputs
    ld   a,(_OP1+1)
    ld   b,a
    ld   hl,_OP1+2
    call _vputsn
    ld   hl,Spaces_Str
    call _vputs
    res  1,(iy+5)
    ret

FindVars:
    ld   hl,0				;start with no vars found
    ld   (TotalVars),hl
    ld   hl,AVAT				;setup the avat pointer
    ld   (Pointer2AVAT),hl
    ld   hl,$BFFF
    ld   a,$47
    out  (6),a
SearchLoop:
    ld   de,(VAT_END)
    inc  de
    or   a
    sbc  hl,de
    ret	 c
    add  hl,de
    ld	 (Pointer2VAT),hl	;this is the start of the vat entry
    ld	 de,-4				;go to where the folder byte is
    add	 hl,de
    ld	 b,(hl)				;this is what folder the var goes in
    ld	 a,(CurFolder)		;this is what folder we want to find
    cp	 b					;check if they are the same
    jp	 nz,SkipVarName		;no? go to here

MoveName2OP1:
    dec  hl
    ld 	 b,(hl)				;save length byte for djnz
    inc	 b
    ld 	 ix,_OP1				;this is where we are gonna put the var name
Name2OP1:
    inc  ix
    ld   a,(hl)
    ld 	 (ix),a
    dec  hl					;simple routine to move b bytes from hl to ix (backward)
    djnz Name2OP1

CheckVarName:
    ld   a,(_OP1+2)
    cp   $10					;check if its a sqrt program
    jp   z,SkipVarName		;thats an evil var
    cp   '#'					;this on is too
    jp   z,SkipVarName
    cp   '!'					;and this one as well
    jp   z,SkipVarName
    cp   'm'					;check if its mse
    jr   nz,LoadVar
    ld   a,(_OP1+3)
    cp   's'
    jr   nz,LoadVar
    ld   a,(_OP1+4)
    cp   'e'
    jp   z,SkipVarName

LoadVar:
    rst  10h
    ld   a,b
    ex   de,hl
    call _load_ram_ahl
    call SetPorts4Move
    inc	 hl
    inc	 hl					;this is where the good stuff starts in a program
    ld   (tmpVarPtr),hl		;save this for later use
    ld   ix,dtVAT			;ix it the table
    ld   a,(TotalDTs)
    ld   c,a

CompareVar2Table:				;hl is the program, ix is the var table
    ld   a,(_OP1)			;var type is in (_OP1)
    cp   (ix)				;and hl is pointing at the var type 
    jr   nz,FixIX
MainSearchLoop:
    inc  ix
    inc  ix
    ld   a,(ix)					;get the table length
    push ix						;save when its at the table length byte
    inc  ix						;point to the table
    ld   b,a					;use b as the counter
	inc  b						;gotta do b+1 to make it iterate correctly
    ld   hl,(tmpVarPtr)
    call CompareBytesLoop
    pop  ix
    jr   nc,GoodVarFound
TryNextDT:
    dec  c
    ld   a,0
    cp   c
    jp   z,SkipVarName
    ld   a,(ix)
    add  a,a
    add  a,10
    ld   e,a
    ld   d,0
    add  ix,de
    jr   CompareVar2Table
FixIX:
    inc  ix
    inc  ix
    jr   TryNextDT

CompareBytesLoop:
    or   a						;reset carry flag
    dec  b
    ret  z						;ret if b is 0
    ld   a,(ix)
    ld   (jumper),a
    inc  ix
    ld   a,(ix)
    cp   (hl)
    inc  hl
    inc  ix
jumper:
    jr   CompareBytesLoop
    scf
    ret

GoodVarFound:
    dec  ix
    ld   a,(ix)
    ld   (_OP1),a
    dec  ix
    ld   (_OP1+10),ix
    ld   hl,_OP1
    ld 	 de,(Pointer2AVAT)
    ld   bc,12				;12 bytes from _OP1 to the AVAT
    ldir
    ld   hl,(Pointer2AVAT)
    ld   de,12
    add  hl,de
    ld   (Pointer2AVAT),hl
    ld   a,(TotalVars)
    inc  a
    ld   (TotalVars),a
SkipVarName:
    ld   a,$0d
    out  (5),a
    ld   a,$47
    out  (6),a
    ld  hl,(Pointer2VAT)
    ld  de,-5
    add  hl,de
    ld   b,(hl)
    inc  b
SkipName: 
    dec  hl
    djnz SkipName
    jp   SearchLoop

DispProgs:
    call ClearProgPlace	
    ld   a,1
    ld   (Posr),a
TheMoveLoop:
    call DisplayHandler
    ld   a,(Posr)
    inc  a
    ld   (Posr),a
    cp   17
    ret  z
    ld   a,(CurVar)
    ld   hl,TotalVars
    cp   (hl)
    ret  z
    inc  a
    ld   (CurVar),a
    jr   TheMoveLoop	

UpdateCurProg:
    ld   a,(CurVar)
    ld   h,a
    ld   l,12
    call MUL_HL
    ld   de,AVAT-12
    add  hl,de
    ret 

GetdtVar:
    call UpdateCurProg
    ld   de,10
    add  hl,de
    ex   de,hl
    ld   a,(de)
    ld   l,a
    inc  de
    ld   a,(de)
    ld   h,a
    inc  hl
    inc  hl
    ld   a,(hl)
    add  a,a
    ld   e,a
    ld   d,0
    add  hl,de
    rst  20h
    rst  10h
    ld   a,b
    ex   de,hl
    call _load_ram_ahl	
    call SetPorts4Move
    inc  hl
    inc  hl						;past the size			
    ret
 
SetPortsNorm:
    ld   a,$0D					;put the pages back so we dont fuck stuff up
    out  (5),a
    ld   a,$41
    out  (6),a
    ret

SetPorts4Move:
    in   a,(6)					;and setup the program
    out  (5),a					;for searching.
    inc  a
    out  (6),a
    ld   de,-$4000
    add  hl,de
    ret 

DrawVLine:
    ld   a,(hl)
    or   c
    ld   (hl),a
    add  hl,de

    djnz DrawVLine

    ret

DrawHLine:
    ld   a,$FF
    ld   (hl),a

    inc  hl

    djnz DrawHLine

    ret

ClearProgPlace:
    ld   hl,$FC74
    ld   c,49

    ld   b,12

ClearVars:
    ld   a,0
    ld   (hl),a

    inc  hl

    djnz ClearVars

    ld   de,4

    add  hl,de

    dec  c

    ld   a,c

    or   a

    ld   b,12
    jr   nz,ClearVars

    call DoLines
    ret

ClearDescriptPlace:
    ld   hl,$FF90
    ld   b,112
ClearDesc:
    xor  a
    ld   (hl),a
    inc  hl
    djnz ClearDesc
    ret

DispIt:
    ld   (_penCol),de
    call _vputs
    ret

InvertSelector:
    ld   a,(Posl)
    ld   h,a
    ld   l,$60
    call MUL_HL
    ld   de,$FC10
    add  hl,de			
    call InvertBar
    call DoLines
    ret

InvertBar:
    ld   c,7

    ld   b,4

Inverter:
    ld   a,(hl)
    cpl
    ld   (hl),a

    inc  hl

    djnz Inverter

    ld   de,12

    add  hl,de

    dec  c

    ld   a,c

    or   a

    ld   b,4
    jr   nz,Inverter

    ret 

DoTopBar:
    ld   de,$0003
    ld   hl,ProgramName
    call DispIt
    ld   hl,$FC00
    call InvertFullBar
    ret 

GetFreeMem:
	ld   hl,$3902
	ld   (_penCol),hl
	ld   hl,FreeStr
	call _vputs
	call _memchk
	call DispHL
	ld   hl,BytesStr
	call _vputs
	ret

DoLines:
    ld   b,49

    ld   hl,$FC70

    ld   c,%10000000

    ld   de,16

    call DrawVLine
    ld   b,49

    ld   hl,$FC7F

    ld   c,%00000001

    ld   de,16

    call DrawVLine
    ld   b,49

    ld   hl,$FC74

    ld   c,%10000000

    ld   de,16

    call DrawVLine
    ld   b,16
    ld   hl,$FF80
    call DrawHLine
    ret

Exit:
    call SaveVars
    res  4,(iy+9)
    call _homeup
    jp   _clrScrn

ShutCalcOff:
    res  3,(iy+8)

    set  4,(iy+8)

    call _off

    ld   a,$FF
    ret

InvertFullBar:
    ld   b,$70

InvertFullBarLoop:
    ld   a,(hl)

    cpl
    ld   (hl),a

    inc  hl

    djnz InvertFullBarLoop

    ret

DispHL:
    ld   de,-1

    ld   (_curRow),de

    call _dispahl

    dec  hl

    call _vputs

    ret

ContrastDn:
    ld   a,-1

    jr   ContrastMain

ContrastUp:
    ld	 a,1

ContrastMain:
    ld	 hl,CONTRAST

    add	 a,(hl)

    and	 $1F

    ld	 (hl),a

    out	 (2),a

    ld	 a,$FF
    ret

SaveVars:
    call _op1toop5
    ld   hl,mseVAT
    rst  20h
    rst  10h
    ret  c
    ld   a,b
    ex   de,hl
    call _load_ram_ahl
    call SetPorts4Move
    ld   de,PosStatus-$D748+4
    add  hl,de
    ld   bc,6
    ex   de,hl
    ld   hl,PosStatus
    ldir
    call SetPortsNorm
    call _op5toop1
    ret

ProgramName:
    .db "MSE v4.0  by Chicane",0

FirstString:
    .db $0C,$01,$01

mseVAT:
    .db $12,$03,"mse"

Folder1:
    .db "/root",0
    
Folder2:
    .db "/games",0
    
Folder3:
    .db "/math",0
    
Folder4:
    .db "/science",0
    
Folder5:
    .db "/docs",0
    
Folder6:
    .db "/code",0
    
Folder7:
    .db "/include",0
	
Recycle:
    .db "/recycle",0

SizeStr:
    .db "Size:",0

TypeStr:
    .db "Type:",0

Spaces_Str:
    .db "   ",0

NoProgs_Str:
    .db "No Programs",0

FreeStr:
    .db "Free Memory: ",0

BytesStr:
    .db " bytes",0

tmpVarPtr:
    .dw 0000

PosStatus:
    .db 0              ; 0 for normal menu, 1 for folders menu

Posl:
    .db	1
    
Posr:
    .db 1

VarPage:
    .db 1

CurVar:
    .db 1
    
CurFolder:
    .db 0

.end
